#include <experimental/random>
#include <bits/stdc++.h>

using namespace std;
//experimental::randint(1, 10);
#define ll long long

ll MOD = 998244353;
ll INF = 1e18;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll tt;
    cin >> tt;
    ll n, m;
    cin >> n >> m;
    vector<ll> s(n);
    vector<ll> col(2);
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
        col[s[i] % 2]++;
    }
    string z;
    cin >> z;
    if (col[0] != 0 && col[1] != 0) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << endl;
    if (tt == 1) {
        return 0;
    }
    ll h = m / 2;
    if (tt == 2) {
        cout << h;
    } else {
        cout << h << endl;
        cout << 1 << endl;
        cout << h << " " << h;
    }
}
